#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_InsideId.h"
std::auto_ptr<M_InsideId> M_InsideId::msSingleton(nullptr);

int M_InsideId::GetCount()
{
	return (int)mMapData.size();
}

const M_InsideIdData* M_InsideId::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_InsideIdData>& M_InsideId::GetMapData()
{
	return mMapData;
}

void M_InsideId::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_InsideId.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_InsideIdData data;
		data.mId = element->IntAttribute("Id");
		data.mPlayerId = element->IntAttribute("PlayerId");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_InsideId Loaded. Load Data:%u", mMapData.size());
}

void M_InsideId::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_InsideId");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_InsideId");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_InsideIdData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "PlayerId", data.mPlayerId);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_InsideId Loaded. Load Data:%u", mMapData.size());
}

void M_InsideId::Reload()
{
	mMapData.clear();
	Load();
}

M_InsideId* M_InsideId::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_InsideId());
	}
	return msSingleton.get();
}

void M_InsideId::Release()
{
	msSingleton.reset(nullptr);
}
